﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Drawing;
using System.ComponentModel;
using System.Drawing.Drawing2D;

namespace Graph
{
    public class GraphControl : Control
    {
        List<int> points;
        public GraphControl()
        {
            points = new List<int>();
        }
        Color eff = Color.Red;
        [Browsable(true)]
        public Color Effekt
        {
            get
            {
                return eff;
            }
            set
            {
                eff = value;
            }
        }
        int max = 100;
        [Browsable(true)]
        public int Max
        {
            get
            {
                return max;
            }
            set
            {
                max = value;
            }
        }
        protected override void OnPaint(PaintEventArgs e)
        {
            base.OnPaint(e);
            //Render Background
            e.Graphics.Clear(BackColor);
            //Effekt
            e.Graphics.FillRectangle(
                new LinearGradientBrush(
                    new Point(this.Width / 2, 0),
                    new Point(this.Width / 2, this.Height / 2),
                    eff, this.BackColor),
                    new Rectangle(0, 0, Width, Height / 2));
            if (points.Count > max)
                points.RemoveRange(max, points.Count - max);
            e.Graphics.TranslateTransform((float)Width / 2, (float)Height / 2);
            e.Graphics.RotateTransform(180);
            e.Graphics.TranslateTransform(-(float)Width / 2, -(float)Height / 2);

            //Draw Points
            if (points.Count > 1 && max != 0)
            {
                List<Point> fs = new List<Point>();
                for (int i = 0; i < points.Count; i++)
                {
                    fs.Add(new Point((int)(((float)Width / (float)max) * i), (int)((float)points[i] / 100.0f * (float)Height)));
                }
                    
                e.Graphics.DrawCurve(new Pen(ForeColor), fs.ToArray());
            }
            e.Graphics.TranslateTransform((float)Width / 2, (float)Height / 2);
            e.Graphics.RotateTransform(180);
            e.Graphics.TranslateTransform(-(float)Width / 2, -(float)Height / 2);
            //Text
            e.Graphics.DrawString(Text, Font, new SolidBrush(ForeColor), 10.0f, 10.0f);
        }
        public void Add(int p)
        {
            points.Insert(0, p);
            this.Invalidate();
        }
        protected override void OnSizeChanged(EventArgs e)
        {
            this.Invalidate();
            base.OnSizeChanged(e);
        }
    }
}
